package com.muzhi.tianhe.controller;

import com.muzhi.tianhe.service.DingService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @Author ZhangKan
 * @Data 15:03
 */

@Api(description = "钉钉接口")
@CrossOrigin
@RestController
@RequestMapping("/dingOAservice")
public class DingController {

    @Autowired
    private DingService dingService;

    //获取钉钉OA审批信息（任务）
    @ApiOperation(value = "获取钉钉OA审批信息（任务）")
    @PostMapping("getDingOA")
    public String getDingOA(String processInstances){

        String dingOA = dingService.getDingOA(processInstances);
        return dingOA;
    }

    //获取钉钉OA审批信息（变更）
    @ApiOperation(value = "获取钉钉OA审批信息（变更）")
    @PostMapping("getDingOAbiangeng")
    public String getDingOAbiangeng(String processInstances, String shenheyijian){

        String dingOAbiangeng = dingService.getDingOAbiangeng(processInstances, shenheyijian);
        return dingOAbiangeng;
    }

    //获取钉钉OA审批信息（关键任务变更）
    @ApiOperation(value = "获取钉钉OA审批信息（关键任务变更）")
    @PostMapping("getDingOAbiangeng2")
    public String getDingOAbiangeng2(String processInstances, String shenheyijian){

        String dingOAbiangeng2 = dingService.getDingOAbiangeng2(processInstances, shenheyijian);
        return dingOAbiangeng2;
    }

    //获取钉钉OA审批信息（额外增加1：会议决议完成情况审核）
    @ApiOperation(value = "获取钉钉OA审批信息（额外增加1：会议决议完成情况审核）")
    @PostMapping("getDingOAbiangeng3")
    public String getDingOAbiangeng3(String processInstances){

        String dingOAbiangeng3 = dingService.getDingOAbiangeng3(processInstances);
        return dingOAbiangeng3;
    }
}
