package com.muzhi.tianhe.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.dingtalkyida_1_0.models.CreateOrUpdateFormDataResponse;
import com.aliyun.dingtalkyida_1_0.models.StartInstanceHeaders;
import com.aliyun.dingtalkyida_1_0.models.StartInstanceRequest;
import com.aliyun.tea.TeaException;
import com.aliyun.teautil.models.RuntimeOptions;
import com.muzhi.tianhe.service.AccessTokenService;
import com.muzhi.tianhe.service.YiDaService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class YiDaServiceImpl implements YiDaService {

    @Autowired
    private AccessTokenService accessTokenService;

    public static String body = null;
    public static String result = null;


    /**
     * 使用 Token 初始化账号Client
     * @return Client
     * @throws Exception
     */
    public static com.aliyun.dingtalkyida_1_0.Client createClient() throws Exception {
        com.aliyun.teaopenapi.models.Config config = new com.aliyun.teaopenapi.models.Config();
        config.protocol = "https";
        config.regionId = "central";
        return new com.aliyun.dingtalkyida_1_0.Client(config);
    }

    @Override
    public String createYiDaXM(String mapJson,String xmid) throws Exception{

        //创建或更新宜搭表单
        /*测试数据*/
//        mapJson = "{\"textField_ljzik5xb\":\"64acf5950f2e439900ff109d\",\"textField_ljzik5xd\":\"PM2023-030 门厅漆面工程\",\"textField_lk0qrye4\":\"客户现场产品（软件）调试的标准业务流程、规范、交付物\"}\n";
//
//        xmid = "111";

        /*同步至宜搭*/

        //宜搭表单判断查询条件
        Map map1 = new HashMap();
        //字段编号
        map1.put("key","textField_ljzik5xb");
        //项目ID编号
        map1.put("value", xmid);
        //控件类型
        map1.put("type","TEXT");
        //逻辑判断符
        map1.put("operator","eq");
        //控件名称
        map1.put("componentName","TextField");

        List list11 = new ArrayList();
        list11.add(map1);

        String listJson = JSON.toJSONString(list11);
        System.out.println("查询条件listJson：" + listJson);


        //新增或更新表单实例【宜搭】
        JSONObject jsonObject = null;
        try {
            com.aliyun.dingtalkyida_1_0.Client client11 = createClient();
            com.aliyun.dingtalkyida_1_0.models.CreateOrUpdateFormDataHeaders createOrUpdateFormDataHeaders = new com.aliyun.dingtalkyida_1_0.models.CreateOrUpdateFormDataHeaders();
            createOrUpdateFormDataHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
            com.aliyun.dingtalkyida_1_0.models.CreateOrUpdateFormDataRequest createOrUpdateFormDataRequest = new com.aliyun.dingtalkyida_1_0.models.CreateOrUpdateFormDataRequest()
                    //应用秘钥
                    .setSystemToken("9H666R71GOFCQDI3BG6LQ8P85P0B3N3LJIZJL3")
                    //表单编码
                    .setFormUuid("FORM-XHA66881VDFCHYS7A3FG57P8U0D02H5PJIZJLK")
                    .setUserId("yida_pub_account")
                    .setSearchCondition(listJson)
                    //应用编码
                    .setAppType("APP_OT7X1YCX3FL4OUCVI1SS")
                    .setFormDataJson(mapJson);

            CreateOrUpdateFormDataResponse orUpdateFormDataWithOptions = client11.createOrUpdateFormDataWithOptions(createOrUpdateFormDataRequest, createOrUpdateFormDataHeaders, new RuntimeOptions());
            String s = JSON.toJSONString(orUpdateFormDataWithOptions.getBody());
            jsonObject = JSON.parseObject(s);
            System.out.println("【创建或更新】表单object对象：" + jsonObject);
        } catch (TeaException err) {
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        } catch (Exception _err) {
            TeaException err = new TeaException(_err.getMessage(), _err);
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        }
        /*同步至宜搭*/

        return "创建宜搭项目表单成功！";
    }

    @Override
    public String createYiDaRW(String dingUserid,String mapJson) throws Exception{

        com.aliyun.dingtalkyida_1_0.Client client = createClient();
        StartInstanceHeaders startInstanceHeaders = new StartInstanceHeaders();
        startInstanceHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
        StartInstanceRequest startInstanceRequest = new StartInstanceRequest()
                .setAppType("APP_T3TFV4N6RKNJJE2G78NY")
                .setSystemToken("N4A66IB1II3A3OXXEG08F7WBXJV72G9ACWFHL7Q")
                .setUserId(dingUserid)
                .setLanguage("zh_CN")
                .setFormUuid("FORM-OS566L918B9A5CO89BLL3857BAWJ2R3ICWFHLE")
                .setFormDataJson(mapJson);
//                //流程编码
//                .setProcessCode("TPROC--EF6Y4xxx")
//                //发起人所在部门ID
//                .setDepartmentId("18295");
        try {
            client.startInstanceWithOptions(startInstanceRequest, startInstanceHeaders, new RuntimeOptions());
        } catch (TeaException err) {
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        } catch (Exception _err) {
            TeaException err = new TeaException(_err.getMessage(), _err);
            if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                // err 中含有 code 和 message 属性，可帮助开发定位问题
            }

        }

        return "创建宜搭任务表单成功！";
    }

}
